Summary:         A Modern Linker
Name:            mold
Version:         2.1.0
Release:         3%{?dist}
License:         MIT AND (Apache-2.0 OR MIT)
URL:             https://github.com/rui314/mold
Source0:         %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

# fix on ppc64le (https://github.com/rui314/mold/issues/1087)
Patch0001:		   0002-Avoid-reading-data-from-.plt.patch
Patch0002:		   0003-Avoid-reading-data-from-.plt.patch
Patch3000:       tbb-strip-werror.patch
Patch3001:       Use-system-compatible-include-path-for-xxhash.h.patch

BuildRequires:   cmake gcc gcc-c++ >= 10
BuildRequires:   libzstd-devel mimalloc-devel openssl-devel xxhash-devel zlib-devel hwloc-devel
BuildRequires:   clang gdb glibc-static libdwarf-tools libstdc++-static llvm
%ifarch x86_64
BuildRequires:   /usr/lib64/libc.so
%endif

Requires(post):  %{_sbindir}/alternatives
Requires(preun): %{_sbindir}/alternatives

Provides:	bundled(tbb) = 2021.9

%description
mold is a faster drop-in replacement for existing Unix linkers.
It is several times faster than the LLVM lld linker.
mold is designed to increase developer productivity by reducing
build time, especially in rapid debug-edit-rebuild cycles.

%prep
%autosetup -p1
rm -r third-party/{mimalloc,xxhash,zlib,zstd}

%build
%cmake -DMOLD_USE_SYSTEM_MIMALLOC=ON
%cmake_build

%install
%cmake_install

%post
if [ "$1" = 1 ]; then
  %{_sbindir}/alternatives --install %{_bindir}/ld ld %{_bindir}/ld.mold 1
fi

%postun
if [ "$1" = 0 ]; then
  %{_sbindir}/alternatives --remove ld %{_bindir}/ld.mold
fi

%check
%ctest

%files
%license %{_docdir}/mold/LICENSE
%license %{_docdir}/mold/LICENSE.third-party
%ghost %{_bindir}/ld
%{_bindir}/mold
%{_bindir}/ld.mold
%{_libdir}/mold/mold-wrapper.so
%{_libexecdir}/mold/ld
%{_mandir}/man1/ld.mold.1*
%{_mandir}/man1/mold.1*

%changelog
* Mon Dec 25 2023 luffyluo <luffyluo@tencent.com> - 2.1.0-3
- Rebuilt for llvm 17.0.6

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.0-2
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 24 2023 Wang Guodong <gordonwwang@tencent.com> - 2.1.0-1
- Upgrade to version 2.1.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.7.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.7.1-2
- Rebuilt for OpenCloudOS Stream 23

* Sat Dec 17 2022 Miaojun Dong <zoedong@tencent.com> - 1.7.1-1
- initial build
